
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>LSTMs with normalization &#8212; Battery SOH 2022 documentation</title>
    
  <link href="../_static/css/theme.css" rel="stylesheet" />
  <link href="../_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/basic.css" />
    
  <link rel="preload" as="script" href="../_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <link rel="next" title="LSTMs with chemistry" href="LSTMchem.html" />
    <link rel="prev" title="Regular LSTMs" href="LSTM.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="../index.html">
  <img src="../_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 current active nav-item">
 <a class="reference internal nav-link" href="Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    <ul class="nav bd-sidenav">
 <li class="toctree-l1">
  <a class="reference internal" href="LSTM_Base.html">
   Base Classes
  </a>
 </li>
</ul>
<ul class="current nav bd-sidenav">
 <li class="toctree-l1">
  <a class="reference internal" href="LSTM.html">
   Regular LSTMs
  </a>
 </li>
 <li class="toctree-l1 current active">
  <a class="current reference internal" href="#">
   LSTMs with normalization
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="LSTMchem.html">
   LSTMs with chemistry
  </a>
 </li>
</ul>

  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
              
              <div class="toc-item">
                
<div class="tocsection onthispage pt-5 pb-3">
    <i class="fas fa-list"></i> On this page
</div>

<nav id="bd-toc-nav">
    <ul class="visible nav section-nav flex-column">
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#models">
   Models
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#dataset-class">
   Dataset Class
  </a>
 </li>
</ul>

</nav>
              </div>
              
              <div class="toc-item">
                
              </div>
              
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  <div class="section" id="lstms-with-normalization">
<span id="lstms-norm"></span><h1>LSTMs with normalization<a class="headerlink" href="#lstms-with-normalization" title="Permalink to this headline">¶</a></h1>
<p>This module (<code class="xref py py-mod docutils literal notranslate"><span class="pre">LSTM_with_norm</span></code>) contains the models that include the
normalisation parameters (<code class="docutils literal notranslate"><span class="pre">norm</span></code> tuple) as optimizable parameters, that can be
trained with or without the rest of the neural network.</p>
<p>Methods <a class="reference internal" href="#LSTM_with_norm.LSTM_v1.enable_training" title="LSTM_with_norm.LSTM_v1.enable_training"><code class="xref py py-func docutils literal notranslate"><span class="pre">enable_training()</span></code></a> and
<a class="reference internal" href="#LSTM_with_norm.LSTM_v1.disable_training" title="LSTM_with_norm.LSTM_v1.disable_training"><code class="xref py py-func docutils literal notranslate"><span class="pre">disable_training()</span></code></a> can be used to
enable and disable training of the neural network’s parameters.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>As of now, there isn’t a method for disabling/re-enabling training of the
normalisation parameters (since they are the whole point of these models).
<a class="reference internal" href="code_examples.html#norm-train"><span class="std std-ref">Here’s</span></a> a code that does just that in case you need it.</p>
</div>
<p>Usually, these models are used exclusively to optimize the normalisation
parameters. Optimizing them at the same time as the neural network has not been
attempted.</p>
<p>In order to get the network’s parameters from another model, first initialize
the desired model (<code class="docutils literal notranslate"><span class="pre">norm</span></code> can be initialized as <code class="docutils literal notranslate"><span class="pre">None</span></code>, though it won’t work
until you define an actual value) then call the <code class="xref py py-func docutils literal notranslate"><span class="pre">from_model()</span></code> method with
the old model you want to get the NN parameters of.</p>
<p>Models from this module also have a <code class="xref py py-func docutils literal notranslate"><span class="pre">change_norm()</span></code> method, where the user
can directly input a norm, facilitating the process of alternating between
norms.</p>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>After training a model’s normalisation parameters, make sure to call the
<code class="docutils literal notranslate"><span class="pre">update_norm()</span></code> method. It ensures that the saved <code class="docutils literal notranslate"><span class="pre">norm</span></code> attribute is
updated. This is necessary because the parameters updated during training
are stored in other attributes.</p>
<p>This will not affect the model’s performance, it’s just useful for when
calling the model’s normalisation parameters in the standard <code class="docutils literal notranslate"><span class="pre">norm</span></code> form
through the <code class="docutils literal notranslate"><span class="pre">norm</span></code> attribute. <strong>Not updating the attribute may result in
silent errors in other functions or when calling it in the future</strong>.</p>
</div>
<p>Example of training an LSTM with norm:</p>
<div class="highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">LSTM</span> <span class="kn">import</span> <span class="o">*</span>
<span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">LSTM_with_norm</span> <span class="k">as</span> <span class="nn">wn</span>
<span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">Training</span> <span class="kn">import</span> <span class="o">*</span>
<span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">MIT_Classes</span> <span class="kn">import</span> <span class="o">*</span>
<span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">main</span>
<span class="gp">&gt;&gt;&gt; </span><span class="c1"># Model version 1 trained with Tarascon&#39;s Coin dataset:</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">report_name</span> <span class="o">=</span> <span class="s1">&#39;2021-08-04 13_53_33.071482-coinv1&#39;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="c1"># getting the model from the report:</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Reports/&#39;</span><span class="o">+</span><span class="n">report_name</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;best_model.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
<span class="gp">... </span>    <span class="n">base_model</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
<span class="gp">...</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../../&#39;</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="c1"># Defining an &quot;Empty&quot; model (the inputs don&#39;t matter because it will)</span>
<span class="gp">... </span><span class="c1"># be reinitialized</span>
<span class="gp">...</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">Model</span> <span class="o">=</span> <span class="n">wn</span><span class="o">.</span><span class="n">LSTM_v1</span><span class="p">(</span><span class="mi">10</span><span class="p">,</span> <span class="mi">10</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">Model</span><span class="o">.</span><span class="n">from_model</span><span class="p">(</span><span class="n">base_model</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="c1"># Skipping dataset creation (we&#39;re using MIT dataset)</span>
<span class="gp">...</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">Model</span><span class="o">.</span><span class="n">change_norm</span><span class="p">(</span><span class="n">train_dataset</span><span class="o">.</span><span class="n">norm</span><span class="p">)</span> <span class="c1"># Using the training dataset norm</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">Model</span> <span class="o">=</span> <span class="n">Model</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span> <span class="c1"># if the device is a GPU</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">Nb_Epochs</span> <span class="o">=</span> <span class="mi">1</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">Learning_Rate</span> <span class="o">=</span> <span class="mf">5e-6</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">_</span><span class="p">,</span><span class="n">_</span><span class="p">,</span><span class="n">_</span><span class="p">,</span><span class="n">date</span> <span class="o">=</span> <span class="n">Train</span><span class="p">(</span><span class="n">train</span><span class="p">,</span> <span class="n">valid_loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">Nb_Epochs</span><span class="p">)</span>
<span class="go">1 . Training loss:  tensor(7.3074e-05)</span>
<span class="go">1 . Validation loss:  tensor(0.0003)</span>
<span class="go">Best validation error: 1</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">Model</span><span class="o">.</span><span class="n">update_norm</span><span class="p">()</span> <span class="c1"># Making sure the Model.norm attribute is updated</span>
</pre></div>
</div>
<p>Check the Google Colab/Notebook file “Normalisation Training.ipynb” for a
step-by-step of how to train a model.</p>
<div class="section" id="models">
<span id="lstm-with-norm-models"></span><h2>Models<a class="headerlink" href="#models" title="Permalink to this headline">¶</a></h2>
<dl class="py class">
<dt class="sig sig-object py" id="LSTM_with_norm.LSTM_v1">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">LSTM_with_norm.</span></span><span class="sig-name descname"><span class="pre">LSTM_v1</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">delta</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">hidden_dim</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">pooling_layer</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'bi_mean'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">drop_out</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">version</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">lin_layers</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">lin_dropout</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/LSTM_with_norm.html#LSTM_v1"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM_with_norm.LSTM_v1" title="Permalink to this definition">¶</a></dt>
<dd><p>LSTM type neural net for Battery SOH estimation.</p>
<p>This model acts just like <a class="reference internal" href="LSTM.html#LSTM.LSTM_v1" title="LSTM.LSTM_v1"><code class="xref py py-class docutils literal notranslate"><span class="pre">LSTM.LSTM_v1</span></code></a>, but includes the
normalisation parameters as optimizable model parameters. Of course, this
also means that the normalisation is done inside the model itself in the
<a class="reference internal" href="#LSTM_with_norm.LSTM_v1.forward" title="LSTM_with_norm.LSTM_v1.forward"><code class="xref py py-func docutils literal notranslate"><span class="pre">forward()</span></code></a> method.</p>
<p>For more information about the model’s architecture, check the documentation
for <a class="reference internal" href="LSTM.html#LSTM.LSTM_v1" title="LSTM.LSTM_v1"><code class="xref py py-class docutils literal notranslate"><span class="pre">LSTM.LSTM_v1</span></code></a>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>delta</strong> (<em>int</em>) – The size of the sliding window used to generate the <img class="math" src="../_images/math/c67734af70861b2bd4dedf5c41c9aad231466f84.png" alt="x_i"/> s.</p></li>
<li><p><strong>hidden_dim</strong> (<em>int</em>) – Hidden dimension of the LSTM (also its main output dimension).</p></li>
<li><p><strong>pooling_layer</strong> (<em>{'last'</em><em>, </em><em>'mean'</em><em>, </em><em>'bi_mean&quot;}</em><em>, </em><em>default = 'bi_mean'</em>) – <p>Decides the type of pooling layer:</p>
<ul>
<li><p><code class="docutils literal notranslate"><span class="pre">'last'</span></code> (only takes the last result),</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">'mean'</span></code> (takes the mean of the results) and</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">'bi_mean'</span></code> (takes the mean of the product).</p></li>
</ul>
<p>The default value is strongly recommended. It’s the one that’s had the
best results, in the article and in our tests.</p>
</p></li>
<li><p><strong>drop_out</strong> (<em>float</em>) – The probability of the dropout layer that comes right after the LSTM.
Must be a number between 0 and 1.</p></li>
<li><p><strong>norm</strong> (<em>tuple</em><em>(</em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>string</em><em>)</em><em>, </em><em>optional</em>) – <p>A tuple containing all of the information necessary for normalization.</p>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>Although the model <em>can</em> be initialized with a <code class="docutils literal notranslate"><span class="pre">None</span></code> norm,
the <a class="reference internal" href="#LSTM_with_norm.LSTM_v1.forward" title="LSTM_with_norm.LSTM_v1.forward"><code class="xref py py-func docutils literal notranslate"><span class="pre">forward()</span></code></a> method won’t be able to be used. This should be
done solely if the user intends to initialize it right after through
the <a class="reference internal" href="#LSTM_with_norm.LSTM_v1.from_model" title="LSTM_with_norm.LSTM_v1.from_model"><code class="xref py py-func docutils literal notranslate"><span class="pre">from_model()</span></code></a> method.</p>
</div>
</p></li>
<li><p><strong>version</strong> (<em>int</em><em>, </em><em>default = 1</em>) – <p>The model version to be used.</p>
<ul>
<li><p><code class="docutils literal notranslate"><span class="pre">version</span> <span class="pre">=</span> <span class="pre">1</span></code> corresponds to the model created by the article cited.</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">version</span> <span class="pre">=</span> <span class="pre">2</span></code> corresponds to the same model, but adapted to take the</p></li>
</ul>
<p>cycle’s temperature data as well.</p>
<ul>
<li><p><code class="docutils literal notranslate"><span class="pre">version</span> <span class="pre">=</span> <span class="pre">3</span></code> is similar to version 1, but takes the ambient</p></li>
</ul>
<p>temperature as an extra input.</p>
</p></li>
<li><p><strong>lin_layers</strong> (<em>int</em><em>, </em><em>default = 1</em>) – The number of linear regression layers. As of now, cannot be greater
than two (<strong>any value different than 1 will set it to two</strong>).</p></li>
<li><p><strong>lin_dropout</strong> (<em>float</em><em>, </em><em>optional</em>) – The value for the dropout layer that comes after the first linear layer
in the regression step. Will only be taken into accouunt if
<code class="docutils literal notranslate"><span class="pre">lin_layers</span></code> &gt; 1.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><strong>AssertionError</strong> – If the version in different than 1, 2 or 3.
    If an unsupported pooling_layer is informed.</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">torch.utils.data</span> <span class="kn">import</span> <span class="n">Dataset</span>
<span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">LSTM</span> <span class="kn">import</span> <span class="o">*</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">delta</span> <span class="o">=</span> <span class="mi">10</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">hidden_dim</span> <span class="o">=</span> <span class="mi">20</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">version</span> <span class="o">=</span> <span class="mi">2</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">model</span> <span class="o">=</span> <span class="n">LSTM_v1</span><span class="p">(</span><span class="n">delta</span><span class="p">,</span> <span class="n">hidden_dim</span><span class="p">,</span> <span class="n">pooling_layer</span><span class="o">=</span><span class="s1">&#39;last&#39;</span><span class="p">,</span> <span class="n">version</span><span class="o">=</span><span class="n">version</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;B0005.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
<span class="gp">... </span>    <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
<span class="gp">...</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">train_dataset</span> <span class="o">=</span> <span class="n">Torch_Dataset_LSTM</span><span class="p">([</span><span class="n">Battery</span><span class="p">],</span> <span class="n">delta</span><span class="p">,</span> <span class="n">version</span><span class="p">,</span> <span class="n">fixed_len</span><span class="o">=</span><span class="mi">150</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">estimated_capacity</span> <span class="o">=</span> <span class="n">model</span><span class="p">(</span><span class="n">train_dataset</span><span class="o">.</span><span class="n">inputs</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">loss_function</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">nn</span><span class="o">.</span><span class="n">MSELoss</span><span class="p">()</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">loss</span> <span class="o">=</span> <span class="n">loss_function</span><span class="p">(</span><span class="n">estimated_capacity</span><span class="p">,</span> <span class="n">train_dataset</span><span class="o">.</span><span class="n">output</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
<span class="go">2.2862</span>
</pre></div>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="LSTM_with_norm.LSTM_v1.from_model">
<span class="sig-name descname"><span class="pre">from_model</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">old_model</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">disable_training</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/LSTM_with_norm.html#LSTM_v1.from_model"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM_with_norm.LSTM_v1.from_model" title="Permalink to this definition">¶</a></dt>
<dd><p>Method for defining the model’s network parameters based on an old
model.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>old_model</strong> (<a class="reference internal" href="LSTM.html#LSTM.LSTM_v1" title="LSTM.LSTM_v1"><em>LSTM.LSTM_v1</em></a>) – The model that we want to take the parameters of.</p></li>
<li><p><strong>disable_training</strong> (<em>bool</em><em>, </em><em>default = True</em>) – Whether or not we want to disable the training of the network
layers.</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="LSTM_with_norm.LSTM_v1.enable_training">
<span class="sig-name descname"><span class="pre">enable_training</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="../_modules/LSTM_with_norm.html#LSTM_v1.enable_training"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM_with_norm.LSTM_v1.enable_training" title="Permalink to this definition">¶</a></dt>
<dd><p>Enables the training of the LSTM’s and Linear layers’ parameters.</p>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="LSTM_with_norm.LSTM_v1.disable_training">
<span class="sig-name descname"><span class="pre">disable_training</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="../_modules/LSTM_with_norm.html#LSTM_v1.disable_training"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM_with_norm.LSTM_v1.disable_training" title="Permalink to this definition">¶</a></dt>
<dd><p>Disables the training of the LSTM’s and Linear layers’ parameters.</p>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="LSTM_with_norm.LSTM_v1.change_norm">
<span class="sig-name descname"><span class="pre">change_norm</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">norm</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/LSTM_with_norm.html#LSTM_v1.change_norm"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM_with_norm.LSTM_v1.change_norm" title="Permalink to this definition">¶</a></dt>
<dd><p>Changes the model’s <code class="docutils literal notranslate"><span class="pre">norm</span></code> attribute as well as the optimizable
parameters’ values.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>norm</strong> (<em>tuple</em>) – The new normalisation tuple.</p>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="LSTM_with_norm.LSTM_v1.update_norm">
<span class="sig-name descname"><span class="pre">update_norm</span></span><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="reference internal" href="../_modules/LSTM_with_norm.html#LSTM_v1.update_norm"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM_with_norm.LSTM_v1.update_norm" title="Permalink to this definition">¶</a></dt>
<dd><p>Updates the model’s <code class="docutils literal notranslate"><span class="pre">norm</span></code> attribute with the parameters’ values.</p>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="LSTM_with_norm.LSTM_v1.forward">
<span class="sig-name descname"><span class="pre">forward</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">inputs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/LSTM_with_norm.html#LSTM_v1.forward"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM_with_norm.LSTM_v1.forward" title="Permalink to this definition">¶</a></dt>
<dd><dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>inputs</strong> – </p>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><strong>NotImplementedError</strong> – When the normalization type is unknown;
    When the pooling layer type is unknown.</p>
</dd>
</dl>
</dd></dl>

</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="LSTM_with_norm.LSTM_v4">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">LSTM_with_norm.</span></span><span class="sig-name descname"><span class="pre">LSTM_v4</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">delta</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">hidden_dim</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">pooling_layer</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'bi_mean'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">drop_out</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">version</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">4</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">lin_layers</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">lin_dropout</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/LSTM_with_norm.html#LSTM_v4"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM_with_norm.LSTM_v4" title="Permalink to this definition">¶</a></dt>
<dd><p>LSTM type neural net for Battery SOH estimation.</p>
<p>This model acts just like <a class="reference internal" href="LSTM.html#LSTM.LSTM_v4" title="LSTM.LSTM_v4"><code class="xref py py-class docutils literal notranslate"><span class="pre">LSTM.LSTM_v4</span></code></a>, but includes the
normalisation parameters as optimizable model parameters. Of course, this
also means that the normalisation is done inside the model itself in the
<a class="reference internal" href="#LSTM_with_norm.LSTM_v4.forward" title="LSTM_with_norm.LSTM_v4.forward"><code class="xref py py-func docutils literal notranslate"><span class="pre">forward()</span></code></a> method.</p>
<p>For more information about the model’s architecture, check the documentation
for <a class="reference internal" href="LSTM.html#LSTM.LSTM_v4" title="LSTM.LSTM_v4"><code class="xref py py-class docutils literal notranslate"><span class="pre">LSTM.LSTM_v4</span></code></a>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>delta</strong> (<em>int</em>) – The size of the sliding window used to generate the <img class="math" src="../_images/math/c67734af70861b2bd4dedf5c41c9aad231466f84.png" alt="x_i"/> s.</p></li>
<li><p><strong>hidden_dim</strong> (<em>int</em>) – Hidden dimension of the LSTM (also its main output dimension).</p></li>
<li><p><strong>pooling_layer</strong> (<em>{'last'</em><em>, </em><em>'mean'</em><em>, </em><em>'bi_mean&quot;}</em><em>, </em><em>default = 'bi_mean'</em>) – <p>Decides the type of pooling layer:</p>
<ul>
<li><p><code class="docutils literal notranslate"><span class="pre">'last'</span></code> (only takes the last result),</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">'mean'</span></code> (takes the mean of the results) and</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">'bi_mean'</span></code> (takes the mean of the product).</p></li>
</ul>
<p>The default value is strongly recommended. It’s the one that’s had the
best results, in the article and in our tests.</p>
</p></li>
<li><p><strong>drop_out</strong> (<em>float</em>) – The probability of the dropout layer that comes right after the LSTM.
Must be a number between 0 and 1.</p></li>
<li><p><strong>norm</strong> (<em>tuple</em><em>(</em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>string</em><em>)</em><em>, </em><em>optional</em>) – <p>A tuple containing all of the information necessary for normalization.</p>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>Although the model <em>can</em> be initialized with a <code class="docutils literal notranslate"><span class="pre">None</span></code> norm,
the <a class="reference internal" href="#LSTM_with_norm.LSTM_v4.forward" title="LSTM_with_norm.LSTM_v4.forward"><code class="xref py py-func docutils literal notranslate"><span class="pre">forward()</span></code></a> method won’t be able to be used. This should be
done solely if the user intends to initialize it right after through
the <a class="reference internal" href="#LSTM_with_norm.LSTM_v4.from_model" title="LSTM_with_norm.LSTM_v4.from_model"><code class="xref py py-func docutils literal notranslate"><span class="pre">from_model()</span></code></a> method.</p>
</div>
</p></li>
<li><p><strong>version</strong> (<em>int</em><em>, </em><em>default = 4</em>) – <p>The model version to be used.
It will take the ambient temperature
as an input directly into the linear layers.</p>
<ul>
<li><p><code class="docutils literal notranslate"><span class="pre">version</span></code> = 4 is analogous to an <a class="reference internal" href="LSTM.html#LSTM.LSTM_v1" title="LSTM.LSTM_v1"><code class="xref py py-class docutils literal notranslate"><span class="pre">LSTM.LSTM_v1</span></code></a>’s version 1</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">version</span></code> = 5 is analogous to an <a class="reference internal" href="LSTM.html#LSTM.LSTM_v1" title="LSTM.LSTM_v1"><code class="xref py py-class docutils literal notranslate"><span class="pre">LSTM.LSTM_v1</span></code></a>’s version 2.</p></li>
</ul>
</p></li>
<li><p><strong>lin_layers</strong> (<em>int</em><em>, </em><em>default = 1</em>) – The number of linear regression layers. As of now, cannot be greater
than two (<strong>any value different than 1 will set it to two</strong>).</p></li>
<li><p><strong>lin_dropout</strong> (<em>float</em><em>, </em><em>optional</em>) – The value for the dropout layer that comes after the first linear layer
in the regression step. Will only be taken into accouunt if
<code class="docutils literal notranslate"><span class="pre">lin_layers</span></code> &gt; 1.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><strong>AssertionError</strong> – If the version in different than 4 or 5.
    If an unsupported pooling_layer is informed.</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">torch.utils.data</span> <span class="kn">import</span> <span class="n">Dataset</span>
<span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">LSTM</span> <span class="kn">import</span> <span class="o">*</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">delta</span> <span class="o">=</span> <span class="mi">10</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">hidden_dim</span> <span class="o">=</span> <span class="mi">20</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">version</span> <span class="o">=</span> <span class="mi">4</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">model</span> <span class="o">=</span> <span class="n">LSTM_v4</span><span class="p">(</span><span class="n">delta</span><span class="p">,</span> <span class="n">hidden_dim</span><span class="p">,</span> <span class="n">pooling_layer</span><span class="o">=</span><span class="s1">&#39;last&#39;</span><span class="p">,</span> <span class="n">version</span><span class="o">=</span><span class="n">version</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;B0005.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
<span class="gp">... </span>    <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
<span class="gp">...</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">train_dataset</span> <span class="o">=</span> <span class="n">Torch_Dataset_LSTM</span><span class="p">([</span><span class="n">Battery</span><span class="p">],</span> <span class="n">delta</span><span class="p">,</span> <span class="n">version</span><span class="p">,</span> <span class="n">fixed_len</span><span class="o">=</span><span class="mi">150</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">estimated_capacity</span> <span class="o">=</span> <span class="n">model</span><span class="p">(</span><span class="n">train_dataset</span><span class="o">.</span><span class="n">inputs</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">loss_function</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">nn</span><span class="o">.</span><span class="n">MSELoss</span><span class="p">()</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">loss</span> <span class="o">=</span> <span class="n">loss_function</span><span class="p">(</span><span class="n">estimated_capacity</span><span class="p">,</span> <span class="n">train_dataset</span><span class="o">.</span><span class="n">output</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
<span class="go">2.2862</span>
</pre></div>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="LSTM_with_norm.LSTM_v4.from_model">
<span class="sig-name descname"><span class="pre">from_model</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">old_model</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">disable_training</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/LSTM_with_norm.html#LSTM_v4.from_model"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM_with_norm.LSTM_v4.from_model" title="Permalink to this definition">¶</a></dt>
<dd><p>Method for defining the model’s network parameters based on an old
model.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>old_model</strong> (<a class="reference internal" href="LSTM.html#LSTM.LSTM_v1" title="LSTM.LSTM_v1"><em>LSTM.LSTM_v1</em></a>) – The model that we want to take the parameters of.</p></li>
<li><p><strong>disable_training</strong> (<em>bool</em><em>, </em><em>default = True</em>) – Whether or not we want to disable the training of the network
layers.</p></li>
</ul>
</dd>
</dl>
</dd></dl>

<dl class="py method">
<dt class="sig sig-object py" id="LSTM_with_norm.LSTM_v4.forward">
<span class="sig-name descname"><span class="pre">forward</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">inputs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/LSTM_with_norm.html#LSTM_v4.forward"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM_with_norm.LSTM_v4.forward" title="Permalink to this definition">¶</a></dt>
<dd><p>Defines the computation performed at every call.</p>
<p>Should be overridden by all subclasses.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Although the recipe for forward pass needs to be defined within
this function, one should call the <code class="xref py py-class docutils literal notranslate"><span class="pre">Module</span></code> instance afterwards
instead of this since the former takes care of running the
registered hooks while the latter silently ignores them.</p>
</div>
</dd></dl>

</dd></dl>

</div>
<div class="section" id="dataset-class">
<span id="lstm-with-norm-dataset"></span><h2>Dataset Class<a class="headerlink" href="#dataset-class" title="Permalink to this headline">¶</a></h2>
<dl class="py class">
<dt class="sig sig-object py" id="LSTM_with_norm.Torch_Dataset_LSTM">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">LSTM_with_norm.</span></span><span class="sig-name descname"><span class="pre">Torch_Dataset_LSTM</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">Battery_list</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">delta</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">model_version</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">print_bool</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">time_step</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">threshold</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0.1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">min_len</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">150</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">fixed_len</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">150</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm_type</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'zscore'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">adimensionalize</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">cycle_lim</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1000000.0</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="../_modules/LSTM_with_norm.html#Torch_Dataset_LSTM"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM_with_norm.Torch_Dataset_LSTM" title="Permalink to this definition">¶</a></dt>
<dd><p>Creates a pytorch Dataset class that can readily be loaded with torch’s
Loader class for training and validation.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>As of know, the values for adimensionalizing variables are defined in
this class. Ideally, they should be defined in the battery classes.
That’s something that can be improved in the future.</p>
</div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>This class can only take in one type of dataset at a time.</p>
</div>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>Battery_list</strong> (<em>list</em><em>[</em><a class="reference internal" href="NASA.html#Nasa_Classes.Clean_Battery" title="Nasa_Classes.Clean_Battery"><em>Clean_Battery</em></a><em>]</em>) – List with the Batteries that we want to use for creating the dataset.</p></li>
<li><p><strong>delta</strong> (<em>int</em>) – The size of the sliding window used to generate the x_i’s.</p></li>
<li><p><strong>model_version</strong> (<em>{1</em><em>, </em><em>2</em><em>, </em><em>3</em><em>, </em><em>4</em><em>, </em><em>5}</em>) – An integer indicating which LSTM version to use.
if <em>version</em> == 1: then only I and V data will be used.
elif <em>version</em> == 2: then I, V and T will be taken into account.
elif <em>version</em> == 3: then I, V and amb_T will be taken into account.
elif <em>version</em> == 4: then I, V and amb_T will be taken into account,
but amb_T will enter directly in the last step, the NN.
elif <em>version</em> == 5: then I, V, T and amb_T will be taken into account,
mixing models 2 and 4. Redundant.</p></li>
<li><p><strong>print_bool</strong> (<em>bool</em><em>, </em><em>default = False</em>) – Whether or not to print some information while the code runs.
Namely, if we want to print the battery’s name and the number of points.</p></li>
<li><p><strong>time_step</strong> (<em>int</em><em>, </em><em>optional</em>) – The desired time step for the resampling procedure.
If <code class="docutils literal notranslate"><span class="pre">None</span></code> is given, than a time step will be automatically generated
by the method <code class="docutils literal notranslate"><span class="pre">time_step_function</span></code>.</p></li>
<li><p><strong>threshold</strong> (<em>float</em><em>, </em><em>default = 0.1</em>) – The minimum capacity value to be considered as relevant [A.h].</p></li>
<li><p><strong>min_len</strong> (<em>int</em><em>, </em><em>default = 10</em>) – The minimum amount of points a charge cycle must have to be considered
as relevant.</p></li>
<li><p><strong>fixed_len</strong> (<em>int</em><em>, </em><em>optional</em>) – if different than <code class="docutils literal notranslate"><span class="pre">None</span></code> (default value), then the charge and discharge
curves will be limited to <code class="docutils literal notranslate"><span class="pre">fixed_len</span></code> points. This will override
<code class="docutils literal notranslate"><span class="pre">min_len</span></code>.</p></li>
<li><p><strong>norm_type</strong> (<em>{'zscore'</em><em>, </em><em>'minmax'}</em>) – A string indicating which kind of normalization to do.</p></li>
<li><p><strong>norm</strong> (<em>tuple</em><em>(</em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>string</em><em>)</em><em>, </em><em>optional</em>) – A tuple containing all of the information necessary for normalization.
In entered as input, <code class="docutils literal notranslate"><span class="pre">norm_type</span></code> will be overridden by norm[4] and the
given information will be used for the normalization</p></li>
<li><p><strong>adimensionalize</strong> (<em>bool</em><em>, </em><em>default = True</em>) – <p>Whether or not to make variables dimensionless before adding them to the
inputs and output lists.</p>
<ul>
<li><p>The Capacity (output) is normalized by the nominal capacity
(<code class="docutils literal notranslate"><span class="pre">Q_nominal</span></code>);</p></li>
<li><p>The Current is normalized by the C rate (<code class="docutils literal notranslate"><span class="pre">C_rate</span></code>) -
which is the current necessary for charging the battery in one hour
(theoretically);</p></li>
<li><p>The Voltage is normalized by the nominal voltage (<code class="docutils literal notranslate"><span class="pre">V_nominal</span></code>),
the voltage at the plateau in the CV part of the charge curve.</p></li>
</ul>
<p>The values of these parameters are defined inside of each battery class.</p>
</p></li>
<li><p><strong>cycle_lim</strong> (<em>int</em><em>, </em><em>optional</em>) – The greatest cycle number to take into account for the dataset creation.
Default equals <code class="docutils literal notranslate"><span class="pre">1e6</span></code> meaning that no cycles will be ignored.</p></li>
</ul>
</dd>
</dl>
<dl class="py attribute">
<dt class="sig sig-object py" id="LSTM_with_norm.Torch_Dataset_LSTM.dataset_name">
<span class="sig-name descname"><span class="pre">dataset_name</span></span><a class="headerlink" href="#LSTM_with_norm.Torch_Dataset_LSTM.dataset_name" title="Permalink to this definition">¶</a></dt>
<dd><p>The name of the dataset (‘Dataset_Nasa’, for instance).</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>str</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="LSTM_with_norm.Torch_Dataset_LSTM.batteries">
<span class="sig-name descname"><span class="pre">batteries</span></span><a class="headerlink" href="#LSTM_with_norm.Torch_Dataset_LSTM.batteries" title="Permalink to this definition">¶</a></dt>
<dd><p>A list with the file name of each battery used.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>list[str]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="LSTM_with_norm.Torch_Dataset_LSTM.dataset_format">
<span class="sig-name descname"><span class="pre">dataset_format</span></span><a class="headerlink" href="#LSTM_with_norm.Torch_Dataset_LSTM.dataset_format" title="Permalink to this definition">¶</a></dt>
<dd><p>A string indicating the type of data format used: ‘You et al. [56]’.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>str</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="LSTM_with_norm.Torch_Dataset_LSTM.inputs">
<span class="sig-name descname"><span class="pre">inputs</span></span><a class="headerlink" href="#LSTM_with_norm.Torch_Dataset_LSTM.inputs" title="Permalink to this definition">¶</a></dt>
<dd><p>A list with the input tensors for each cycle.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>list[Tensors]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="LSTM_with_norm.Torch_Dataset_LSTM.output">
<span class="sig-name descname"><span class="pre">output</span></span><a class="headerlink" href="#LSTM_with_norm.Torch_Dataset_LSTM.output" title="Permalink to this definition">¶</a></dt>
<dd><p>A tensor with the output capacity tensors for each cycle.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>Tensor</p>
</dd>
</dl>
</dd></dl>

<dl class="field-list simple">
<dt class="field-odd">Raises</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>AssertionError</strong> – If the specified value of <code class="docutils literal notranslate"><span class="pre">delta</span></code> is &lt; 1.
    If no batteries are given.
    If the specified version is invalid.
    If <code class="docutils literal notranslate"><span class="pre">model_version</span></code> is 2 or 5 and <code class="docutils literal notranslate"><span class="pre">self.dataset_name</span></code> is
    <code class="docutils literal notranslate"><span class="pre">Clean_Coin_Battery</span></code>.</p></li>
<li><p><strong>ValueError</strong> – If the model_version is unknown.</p></li>
</ul>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">torch.utils.data</span> <span class="kn">import</span> <span class="n">Dataset</span>
<span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">LSTM</span> <span class="kn">import</span> <span class="n">Torch_Dataset_LSTM</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">delta</span> <span class="o">=</span> <span class="mi">10</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">version</span> <span class="o">=</span> <span class="mi">2</span>
<span class="gp">&gt;&gt;&gt; </span><span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;B0005.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
<span class="gp">... </span>    <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
<span class="gp">...</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">train_dataset</span> <span class="o">=</span> <span class="n">Torch_Dataset_LSTM</span><span class="p">([</span><span class="n">Battery</span><span class="p">],</span> <span class="n">delta</span><span class="p">,</span> <span class="n">version</span><span class="p">,</span>
<span class="gp">... </span>                                   <span class="n">fixed_len</span><span class="o">=</span><span class="mi">150</span><span class="p">,</span> <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="go">B0005</span>
<span class="go">165</span>
</pre></div>
</div>
</dd></dl>

</div>
</div>


              </div>
              
              
              <div class='prev-next-bottom'>
                
    <a class='left-prev' id="prev-link" href="LSTM.html" title="previous page">Regular LSTMs</a>
    <a class='right-next' id="next-link" href="LSTMchem.html" title="next page">LSTMs with chemistry</a>

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="../_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2022, Antonio ROCHA AZEVEDO.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>